# my_func (T. Chateau)
import numpy as np
import matplotlib
matplotlib.use('agg')
from matplotlib import pyplot as plt
import matplotlib.patches as patches
import cv2
import pdb
def fig2data(fig):
  fig.canvas.draw()
  w,h = fig.canvas.get_width_height()
  buf = np.fromstring(fig.canvas.tostring_argb(), dtype = np.uint8)
  buf.shape = (h,w,4)
  buf = buf[:,:,1:4]
  return buf
def display(Xr,roi,im,ptsroi,ptsim,disp_pts = False):
  fig = plt.figure()
  axe1 = fig.add_subplot(111)
  #axe2 = fig.add_subplot(122)
  im = cv2.cvtColor(im,cv2.COLOR_BGR2RGB)
  roi = cv2.cvtColor(roi,cv2.COLOR_BGR2RGB)
  im2 = np.zeros((im.shape),dtype = 'uint8')
  imc = np.concatenate((im2,im),axis = 1)
  imc[0:roi.shape[0],0:roi.shape[1],:]=roi
  offx = im.shape[1]
  axe1.imshow(imc)
  # plot rectangles (part and est)
  if disp_pts==True:
    axe1.plot(ptsroi[:,1],ptsroi[:,0],'+r')
    axe1.plot(offx + ptsim[:,1],ptsim[:,0],'+r')
    for i in range(ptsroi.shape[0]):
      axe1.plot([ptsroi[:,1],offx + ptsim[:,1]],[ptsroi[:,0],ptsim[:,0]],'-g')
  implot = fig2data(fig)
  implot = cv2.cvtColor(implot,cv2.COLOR_RGB2BGR)
  return implot
def display_opencv(im,part,X):
  #Display parts
  Nbp = part.shape[0]
  for i in range(Nbp):
    width = int(part[i,2])
    height = int(part[i,3])
    im = cv2.rectangle(im,(int(part[i,0]),int(part[i,1])),(int(part[i,0]+width),int(part[i,1]+height)),(0,255,0),1)
  im = cv2.rectangle(im,(int(X[0]),int(X[1])),(int(X[0]+width),int(X[1]+height)),(0,0,255),2)
  return im
