#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Sep  9 08:36:33 2018
Visual Tracking with particle filter
@author: thierrychateau
"""
import cv2
import os
import my_func as mf
import numpy as np
import matplotlib
matplotlib.use('agg')
from matplotlib import pyplot as plt
from matplotlib.colors import ListedColormap
import my_harris as mh
import pdb  #pdb.set_trace()
import scipy.spatial 
#import math # to check if nan
###
def match(Pt1,Pt2,D,th = 150):
  I = []
  J = []
  while True:
    mintmp = np.min(D)
    if mintmp < th :
      #print(mintmp)
      indmin=np.squeeze(np.argwhere(D == mintmp)[0])
      indI = indmin[0]
      indJ = indmin[1]
      I.append(indI)
      J.append(indJ)
      D[indI,:]=th + 1
      D[:,indJ]=th + 1
    else:
      break
  Pt1 = Pt1[I,:]
  Pt2 = Pt2[J,:]
  return Pt1, Pt2

def getfeature(im,pts,roiSize=11):
  # Get features (grayscale ROI)
  hsize = int((roiSize-1)/2)
  c1 = pts[:,0]> hsize+1
  c2 = pts[:,1]> hsize+1
  c3 = pts[:,0]< im.shape[1] - (hsize+1)
  c4 = pts[:,1]< im.shape[0] - (hsize+1) 
  c = np.logical_and(c1,c2)
  c = np.logical_and(c,c3)
  c = np.logical_and(c,c4)
  pts = pts[c,:]
  z = np.zeros((pts.shape[0],(hsize*2+1)*(hsize*2+1)*im.shape[2]))
  for i in range(pts.shape[0]):
    z[i,:] = im[pts[i,1]-hsize:pts[i,1]+hsize+1,pts[i,0]-hsize:pts[i,0]+hsize+1].flatten()
  return pts , z # return pts and z (keep only pts without border effect)
def getmodel(X,im):
  roi = im[int(X[1]):int(X[1]+X[3]), int(X[0]):int(X[0]+X[2]),:]
  # Get Harris Interest Points with Opencv
  ptsMod = mh.harris(roi[:,:,0]) # for one channel
  pts, z = getfeature(roi,ptsMod)
  return roi, pts, z
###
###
def main():
  Basename = '../im/'   #basename of image files
  #Basename = '/home/SCIENCES/thchatea/Public/Chateau/Datas/images_tracking_opencv/soccer_01/soccer'   #basename of image files
  ext = 'ppm' # extension used
  FirstImage = 1 # first image of the sequence
  LastImage = 135 # last  image of the sequence
  step = 1 #step between 2 images 
  first = True  
  Nbp = 200  #Nb of particles
  DISPLAY_OPENCV = False
  Pmem = []
  for i in range(FirstImage, LastImage,step):
    filename = "%s%0.8d.%s" % (Basename,i,ext)
    print(filename)
    im = cv2.imread(filename)
    if first:
      r = cv2.selectROI(im)
      X=np.ones(4)
      X[0] = X[0]*int(r[0])
      X[1] = X[1]*int(r[1])
      X[2] = X[2]*int(r[2])
      X[3] = X[3]*int(r[3])
      # Get model (crop image)
      # To be filled by student 
      first = False
    else:
      # Compute Harris on current frame for one channel 
      # To be filled by student 
      # Get feature
      # To be filled by student 
      # Compute distance matrix
      D = scipy.spatial.distance.cdist(ptMod,pts, 'euclidean')
      # Match      
      # To be filled by student 
      if DISPLAY_OPENCV:
        implot =  mf.display_opencv(im, part, X)
      else:
        implot = mf.display(X,roi,im,pt1,pt2,disp_pts = True)
      cv2.imshow('plot',implot)
      if cv2.waitKey(1) & 0xFF == ord('q'):
          break
      #pdb.set_trace()
    
if __name__ == "__main__":
    # execute only if run as a script
    main()
    

